using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp2
{
    internal class Program
    {
        static long XorDjelilaca(long x, long[] sviDjelioci)
        {
            long rez = 0;
            foreach (var d in sviDjelioci)
            {
                if (d > x) break;
                if (x % d == 0)
                    rez ^= d;
            }
            return rez;
        }

        static long[] djelioci(long n)
        {
            List<long> list = new List<long>();
            for (long i = 1; i * i <= n; i++)
            {
                if (n % i == 0)
                {
                    list.Add(i);
                    if (i * i != n)
                        list.Add(n / i);
                }
            }
            list.Sort();
            return list.ToArray();
        }

        static void Main()
        {
            var p1 = Console.ReadLine().Split().Select(long.Parse).ToArray();
            long n = p1[0];
            int k = (int)p1[1];

            var delioci = Console.ReadLine().Split().Select(long.Parse).ToArray();

            var sviDjelioci = djelioci(n);

            foreach (var d in delioci)
            {
                Console.Write(XorDjelilaca(d, sviDjelioci) + " ");
            }
        }

    }
}